import * as server from "@minecraft/server"
const world = server.world

var iterator = 1;
world.afterEvents.itemUse.subscribe(result => {
    if (result.itemStack.typeId.includes('rev') && result.itemStack.typeId.includes('boomerang')) {
        result.itemStack.getComponent('minecraft:cooldown');
        result.source.runCommandAsync('execute as @e[family=boomerang,tag=justSpwn] run tag @s add boom_' + iterator + '');
        result.source.runCommandAsync('execute as @s if entity @e[family=boomerang,tag=justSpwn] run tag @s add throwing_' + iterator + '');
        result.source.runCommandAsync('execute as @e[family=boomerang,tag=justSpwn] run tag @s remove justSpwn');
        console.warn(iterator);
        iterator = iterator + 1;
        if (iterator >= 20) {
            iterator = 1;
        }
    }
});

server.system.runInterval(() => {
    const dimension = world.getDimension('overworld');
    const entities = dimension.getEntities();
    const tags = [
        'boom_1', 'boom_2', 'boom_3', 'boom_4', 'boom_5',
        'boom_6', 'boom_7', 'boom_8', 'boom_9', 'boom_10',
        'boom_11', 'boom_12', 'boom_13', 'boom_14', 'boom_15',
        'boom_16', 'boom_17', 'boom_18', 'boom_19', 'boom_20'
    ];

    entities.forEach(e => {

        if (e.hasTag('returning')) {

            e.runCommandAsync('tp @e[type=item,r=3] @s');
            e.runCommandAsync('tp @e[type=xp_orb,r=3] @s')
            for (const tag of tags) {
                if (e.hasTag(tag)) {
                    e.runCommandAsync(`event entity @s rev:add_rtrn_${tag.slice(5)}`);
                    e.runCommandAsync(`event entity @s rev:tp${tag.slice(5)}`);
                }
            }
        }
    });
}, 1);


console.warn("main.js load")